function [setOfTrainingOs, setOfTestingOs, trainingSentences, testingSentences] = textToSetOfOs(filePath, setOfStatesInMap, trainingPartPercentage)
% sentences - cell array

import java.util.HashMap;
sentences = {};
setOfOs = {};

words = textread(filePath, '%s');
sentence = [];
O = [];
j = 1;
endOfSentence = false;
for i = 1 : length(words)        
    word = lower(words{i});
    
    % cutting out special characters like: ,?!@#$% etc.
    word = cutOutSpecialCharacters(word);         
        
    % checking if end of sentence is met (we assume: '.' can only occur at
    % the end of a word)
    if ~isempty(strfind(word, '.'))
        endOfSentence = true;
        word = word(1 : end - 1);
        sentence = [sentence word];
        sentences{j} = sentence;
        j = j + 1;
        sentence = [];        
    else
        sentence = [sentence word ' '];
    end
    
    observations = extractStates(word);    
    if  ~endOfSentence 
        observations{length(observations) + 1} = ' ';   
    end
    
    for k = 1 : length(observations)
        observation = observations{k};
        if setOfStatesInMap.containsKey(observation)
            O = [O setOfStatesInMap.get(observation)];
        else
            O = [O setOfStatesInMap.get('*')]; % unknown state '*'
        end
    end

    if endOfSentence
        setOfOs{length(setOfOs) + 1} = O;
        O = [];
        endOfSentence = false;
    end
end

index = round(length(setOfOs) * trainingPartPercentage);
setOfTrainingOs = setOfOs(1 : index);
setOfTestingOs = setOfOs(index + 1 : end);

trainingSentences = sentences(1 : index);
testingSentences = sentences(index + 1 : end);